   ////////////////////////////////////bloomshader by rhuarc////////////////////////////////////////////   
    Texture TargetMap;
    float4 vecSkill1;
    
    sampler GlowSampler = sampler_state
    {
        Texture   = (TargetMap);
        MipFilter = LINEAR;
    };
    
   /*
    // This is the plain vertex shader used to overlay the 
    // final glow texture over the rest of the scene.
    TEXTURE_OUTPUT outputGlowVS(GLOW_INPUT IN)
    {
    	TEXTURE_OUTPUT OUT;
    	OUT.pos =  mul(IN.pos, texTrans);
    	OUT.texCoord0 = IN.texCoord;
    	
    	return OUT;
    }
    */
    
    float4 ProcessBloom(float4 colorIn)
    {
      return pow(colorIn,3-vecSkill1.y/2);
    }
    
    float4 glowPS1( float2 Tex : TEXCOORD0) : COLOR0
    { float pSize = vecSkill1.x/12000;
    	float4 color = ProcessBloom(tex2D( GlowSampler, Tex + float2(-pSize*10, 0)) * 0.05);
    	color += ProcessBloom(tex2D( GlowSampler, Tex + float2(-pSize*8, 0)) * 0.2);
    	color += ProcessBloom(tex2D( GlowSampler, Tex + float2(-pSize*6, 0)) * 0.35);
    	color += ProcessBloom(tex2D( GlowSampler, Tex + float2(-pSize*4, 0 )) * 0.4);
    	color += ProcessBloom(tex2D( GlowSampler, Tex + float2(-pSize*3, 0)) * 0.35);
    	color += ProcessBloom(tex2D( GlowSampler, Tex + float2(-pSize*2, 0)) * 0.4);
    	color += ProcessBloom(tex2D( GlowSampler, Tex + float2(-pSize*1, 0)) * 0.5);
    	color += ProcessBloom(tex2D( GlowSampler, Tex + float2(0, 0 )) * 0.5);
      color += ProcessBloom(tex2D( GlowSampler, Tex + float2(pSize*10, 0)) * 0.05);   	
    	color += ProcessBloom(tex2D( GlowSampler, Tex + float2(pSize*8, 0)) * 0.2);
    	color += ProcessBloom(tex2D( GlowSampler, Tex + float2(pSize*6, 0)) * 0.35);
    	color += ProcessBloom(tex2D( GlowSampler, Tex + float2(pSize*4, 0 )) * 0.4);
    	color += ProcessBloom(tex2D( GlowSampler, Tex + float2(pSize*3, 0)) * 0.35);
    	color += ProcessBloom(tex2D( GlowSampler, Tex + float2(pSize*2, 0)) * 0.4);
    	color += ProcessBloom(tex2D( GlowSampler, Tex + float2(pSize*1, 0)) * 0.5);
    	color += ProcessBloom(tex2D( GlowSampler, Tex + float2(0, 0 )) * 0.5);
    	color += ProcessBloom(tex2D( GlowSampler, Tex + float2(0,-pSize*10)) * 0.05);
    	color += ProcessBloom(tex2D( GlowSampler, Tex + float2(0,-pSize*8)) * 0.2);
    	color += ProcessBloom(tex2D( GlowSampler, Tex + float2(0,-pSize*6)) * 0.35);
    	color += ProcessBloom(tex2D( GlowSampler, Tex + float2(0,-pSize*4 )) * 0.4);
    	color += ProcessBloom(tex2D( GlowSampler, Tex + float2(0,-pSize*3)) * 0.35);
    	color += ProcessBloom(tex2D( GlowSampler, Tex + float2(0,-pSize*2)) * 0.4);
    	color += ProcessBloom(tex2D( GlowSampler, Tex + float2(0,-pSize*1)) * 0.5);
    	color += ProcessBloom(tex2D( GlowSampler, Tex + float2(0, 0 )) * 0.5);
    	color += ProcessBloom(tex2D( GlowSampler, Tex + float2(0,pSize*10)) * 0.05);
    	color += ProcessBloom(tex2D( GlowSampler, Tex + float2(0,pSize*8)) * 0.2);
    	color += ProcessBloom(tex2D( GlowSampler, Tex + float2(0,pSize*6)) * 0.35);
    	color += ProcessBloom(tex2D( GlowSampler, Tex + float2(0,pSize*4 )) * 0.4);
    	color += ProcessBloom(tex2D( GlowSampler, Tex + float2(0,pSize*3)) * 0.35);
    	color += ProcessBloom(tex2D( GlowSampler, Tex + float2(0,pSize*2)) * 0.4);
    	color += ProcessBloom(tex2D( GlowSampler, Tex + float2(0,pSize*1)) * 0.5);
    	color += ProcessBloom(tex2D( GlowSampler, Tex + float2(0, 0 )) * 0.5);
    	
    	color.a = 1.0f;
    	
    	return (tex2D( GlowSampler, Tex)+color.rgba*vecSkill1.z/2);
    }
 
     
    
    //////////////////////////
    //  Techniques:
    //////////////////////////
    
    // Four passes blur the texture in different directions.
    // The final one overlays the texture onto the rest of 
    // the scene.
    // Annotations are used so my application can automatically
    // sort these passes into the appropriate rendering stage.
    
    technique T0
    {
    	pass P0
    	{
    		Sampler[0] = (GlowSampler);
    		pixelshader  = compile ps_3_0 glowPS1();
    	}
    }