//---------------------------------------------------------
// Simple Depth of Field Shader by ATI. Converted to 3D Gamestudio by BoH_Havoc
//---------------------------------------------------------
//edited by redphoenix

float4 vecSkill1; //higher value = more blurry
float2 gTapOffset[12] = {
   -0.00326212, -0.00405805,
   -0.00840144, -0.0073580,
   -0.00695914,  0.00457137,
   -0.00203345,  0.00620716,
    0.00962340, -0.00194983,
    0.00473434, -0.00480026,
    0.00519456,  0.00767022,
    0.00185461, -0.00893124,
    0.00507431,  0.00064425,
    0.00896420,  0.00412458,
   -0.00321940, -0.00932615,
   -0.00791559, -0.00597705,

};


texture TargetMap;
texture mtlSkin1;

sampler ColorSampler = sampler_state
{
   texture = (TargetMap);
   MinFilter = linear;
   MagFilter = linear;
   MipFilter = linear;
   AddressU = Clamp;
   AddressV = Clamp;
};

sampler DoFSampler = sampler_state
{
   texture = (mtlSkin1);
   MinFilter = linear;
   MagFilter = linear;
   MipFilter = linear;
   AddressU = Wrap;
   AddressV = Wrap;
};


float4 hlsl_depth_of_field_loop (float2 centerTap: TEXCOORD0) : COLOR
{
	float2 tap[12];
	float4 Color[12];
	float2 Depth[12];
	// Fetch center samples from depth and focus maps
	float4 CenterColor= tex2D (ColorSampler, centerTap);
	float2 CenterFocus= /*(float2)1.0f -*/ tex2D (DoFSampler, centerTap);
	float fTotalContribution = 1.0f;
	float fContribution;
	float fCoCSize= CenterFocus.y * vecSkill1.x/2; // Scale the Circle of Confusion
	for(int i=0; i<12; i++) // Run through all of the taps
	{
		// Compute tap locations relative to center tap
		tap[i] = fCoCSize* gTapOffset[i] + centerTap;
		Color[i] = tex2D(ColorSampler, tap[i]);
		Depth[i] = /*1.0 - */tex2D(DoFSampler, tap[i]);
		// Compute tap's contribution to final color
		fContribution = (Depth[i].x> CenterFocus.x) ? CenterFocus.y: Depth[i].y;
		CenterColor+= fContribution * Color[i];
		fTotalContribution += fContribution;
	}
	float4 FinalColor= CenterColor/ (fTotalContribution); // Normalize
	return FinalColor;
	//return float4(CenterFocus.x,0.0,0.0,1.0);
}

technique PostProcess {
pass p0 {
	//alphablendenable=false;
	//srcblend=zero;
	//VertexShader = compile vs_1_1 vs_down_main();
	PixelShader = compile ps_3_0 hlsl_depth_of_field_loop();
	}
}