//////////////////////////////Dof-Shader by redphoenix/////////////////////////////////////////
/////////////////////basis: http://ati.amd.com/developer/gdc/Scheuermann_DepthOfField.pdf //////////////////

texture TargetMap;
texture mtlSkin1;
texture mtlSkin2;
texture mtlSkin3;
float4 vecViewPort;
float4 vecSkill1;
float2 poisson[12] = {
	{-.326,-.406},
	{-.840,-.074},
	{-.696, .457},
	{-.203, .621},
	{ .962,-.195},
	{ .473,-.480},
	{ .519, .767},
	{ .185,-.893},
	{ .507, .064},
	{ .896, .412},
	{-.322,-.933},
	{-.792,-.598}};


sampler ColorSampler = sampler_state
{
   texture = (TargetMap);
   MinFilter = linear;
   MagFilter = linear;
   MipFilter = linear;
   AddressU = Clamp;
   AddressV = Clamp;
};

sampler DColorSampler = sampler_state
{
   texture = (mtlSkin2);
   MinFilter = linear;
   MagFilter = linear;
   MipFilter = linear;
   AddressU = Clamp;
   AddressV = Clamp;
};

sampler DepthSampler = sampler_state
{
   texture = (mtlSkin1);
   MinFilter = linear;
   MagFilter = linear;
   MipFilter = linear;
   AddressU = Wrap;
   AddressV = Wrap;
};
sampler DDepthSampler = sampler_state
{
   texture = (mtlSkin3);
   MinFilter = linear;
   MagFilter = linear;
   MipFilter = linear;
   AddressU = Wrap;
   AddressV = Wrap;
};

//float radiusScale = 0.4;
float2 vMaxCoC = { 5.0,10.0 };

float4 adv_depth_of_field(float2 Tex: TEXCOORD0) : COLOR {
	float4 cOut;
	cOut = tex2D(ColorSampler,Tex);
	float centerDepth = tex2D(DepthSampler,Tex).a;
	float discRadius = abs(centerDepth*vMaxCoC.y-vMaxCoC.x);
	float discRadiusLow = discRadius*vecSkill1.x/3;
	cOut = 0;
	for (int t=0;t<12;t++) {
		float2 coordLow = Tex + ((vecViewPort.zw)*poisson[t]*discRadiusLow);
		float2 coordHigh = Tex + (vecViewPort.zw*poisson[t]*discRadius);
		float4 tapLow = tex2D(DColorSampler,coordLow);
		float4 tapHigh = tex2D(ColorSampler,coordHigh);
		float tapDepth = tex2D(DepthSampler,coordHigh).a;
		float tapDDepth = tex2D(DDepthSampler,coordLow).a;		
		float tapBlur = abs(tapDepth*2.0 - 1.0);
		tapHigh.a = tapDepth;
		tapLow.a = tapDDepth;
		float4 tap = lerp(tapHigh,tapLow,tapBlur);
		tap.a = (tap.a >= centerDepth) ? 1.0 : abs(tap.a*2.0-1.0);
		cOut.rgb += tap.rgb * tap.a;
		cOut.a += tap.a;
	}
	return (cOut/cOut.a);
}

technique PostProcess {
pass p0 {
	PixelShader = compile ps_3_0 adv_depth_of_field();
	}
}