Texture TargetMap;
sampler2D ColorSampler = sampler_state { texture = <TargetMap>;};

float4 vecViewPort; // contains viewport pixel size in zw components
float4 vecSkill1;

#define NUM_SAMPLES 20
float2 ScreenLightPos;// = {0.5,0.2};
float Density = 0.25;
float illuminationDecay = 2;
float Weight = 0.25;
float Decay = 0.9;
float Exposure = 1;
float Gamma = 1;

float2 poission[7] = {
   //-0.0326212, -0.0405805,
   //-0.0840144, -0.073580,
   -0.00695914,  0.00457137,
   -0.00203345,  0.00620716,
    0.00962340, -0.00194983,
   // 0.0473434, -0.0480026,
   // 0.0519456,  0.0767022,
   // 0.185461, -0.893124,
    0.00507431,  0.0064425,
    0.00896420,  0.00412458,
   -0.00321940, -0.00932615,
   -0.00791559, -0.00597705,
   //0.0,0.0,

};
float4 RadialBlurPS( float2 texCoord : TEXCOORD0 ) : COLOR0 
{
	float2 ScreenLightPos;
	ScreenLightPos.x = 0.5-vecSkill1.x/30;
	ScreenLightPos.y = 0.5-vecSkill1.y/30;
	Density = vecSkill1.z/30;
	texCoord -= vecViewPort.zw;
	float4 OrgScene = tex2D(ColorSampler,texCoord);
	//return OrgSce;
	half2 deltaTexCoord = (texCoord - ScreenLightPos.xy);
	deltaTexCoord *= 1.0f / NUM_SAMPLES * Density;
	half3 color = tex2D(ColorSampler,texCoord);
	
	for(int i = 0; i < NUM_SAMPLES; i++)
	{
		texCoord -= deltaTexCoord;
		half3 sample = tex2D(ColorSampler, texCoord);
		//half3 sample = tex2D(ColorSampler, texCoord);
		//sample *= illuminationDecay * Weight;
		sample *= illuminationDecay;
		//Gamma *= Decay;
		color += sample;
		//illuminationDecay *= Decay;
		illuminationDecay -= 0.1;
	}
	//color *= OrgScene;
	color /= 20;
	return float4(color*Exposure,1);
}

technique radialBlur
{
	pass one
	{
		
		PixelShader = compile ps_2_0 RadialBlurPS();
	}
}